#include <vector>
#include <algorithm>
#include <iostream>

struct positive {
    bool operator() (int i) {
        return i > 0;
    }
};

struct threshold {
    threshold (int t = 0): value(t) {}
    bool operator() (int i) {
        return i > value;
    }
private:
    int value;
};

int main()
{
    std::vector<int> A = {25, 15, 5, -5, -14, 9, -4};
    std::vector<int> B(A.size());

    // 1. uloha: chci kopirovat pouze kladna cisla
    auto it = std::copy_if (A.begin(), A.end(), B.begin(), positive());
    B.resize(std::distance(B.begin(), it));

    std::cout << "B:";
    for (auto i : B) std::cout << i << " ";
    std::cout << std::endl;

    // 2. uloha: chci kopirovat pouze data, ktera jsou vetsi nez nejaka mez - threshold
    // vyuzijeme toho, ze funkcni objekt muze mit parametricky konstruktor, ktery 
    // muze nastavit vnitrni promennou 
    std::vector<int> C(A.size());
    it = std::copy_if (A.begin(), A.end(), C.begin(), threshold(10));
    C.resize(std::distance(C.begin(), it));
    std::cout << "C:";
    for (auto i : C) std::cout << i << " ";
    std::cout << std::endl;

    return 0;
}