#include <map>
#include <iostream>
#include <iomanip>

struct PorovnejTridaA;

class TridaA {
    int value;
public:
    TridaA (int x): value(x) {}
    bool operator< (const TridaA & a) const {
        return (this->value < a.value);
    }
    friend PorovnejTridaA;
    friend std::ostream &operator<< (std::ostream &s, const TridaA &a);
};

std::ostream &operator<< (std::ostream &s, const TridaA &a) {
    s << a.value;
    return s;
}

int main() {

    std::map<std::string, int> D;

    // svetove metropole a pocty obyvatel
    D["Tokyo"] = 37833000;
    D["Dilli"] = 24953000;
    D["Sanghaj"] = 22991000;
    D["Mexico City"] = 20843000;
    D["Sao Paulo"] = 20831000;
    D["Tokyo"] = 3833000;   // multimap umozvuje duplicitni zaznamy

    // par (std::pair) ma dve polozky: firts, second
    for (auto i : D) {
        std::cout << std::setw(12) << std::left << i.first << i.second << "\n";
    }
    std::cout << std::endl;

    D.insert(std::pair<std::string, int>("Prague", 1000000));

    auto ret = D.insert(std::pair<std::string, int>("Sanghaj", 22991000));
    if (ret.second == false) {
        std::cout << "polozka " << ret.first->first << " jiz v kolekci existuje s hodnotou " << ret.first->second << "\n";
    }

    TridaA a1(10), a2(9), a3(5);

    std::map<TridaA, int> A;

    A.insert (std::pair<TridaA, int>(a1, 1));
    A.insert (std::pair<TridaA, int>(a2, 2));
    A.insert (std::pair<TridaA, int>(a3, 3));

    std::map<TridaA, int>::const_iterator i = A.begin();

    for (; i != A.end(); i++) {
        std::cout << std::setw(12) << std::left << i->first << i->second << "\n";
    }
}