#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>

// fibonacci: 0 1 1 2 3 5 8 13 ...
struct fibonacci {
    fibonacci() : curr(0), next(1) {}
    int operator() () {
        int tmp = curr;
        curr = next;
        next += tmp;
        return tmp;
    }
private:
    int curr, next;
};

int main ()
{
    std::cout << std::string(10, 'x') << std::endl;

    std::vector<double> a(10, 1.0);
    fill_n (std::back_inserter(a), 10, 2.0);

    std::copy (a.begin(), a.end(), std::ostream_iterator<double>(std::cout, " "));
    std::cout << std::endl;

    // 1. generate_n (begin, end, func)
    // 2. generate_n (begin, N, func)
    std::vector<int> fib;
    fib.reserve(20);
    generate_n(std::back_inserter(fib), 20, fibonacci());
    std::copy (fib.begin(), fib.end(), std::ostream_iterator<int>(std::cout, " "));
    std::cout << std::endl;

    return 0;
}
